<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8" 
	import="com.pdflib.pCOS,com.pdflib.pCOSException,java.io.PrintWriter,java.io.IOException,java.io.UnsupportedEncodingException" 
	errorPage="error.jsp"%>
	
<%--
	pCOS JSP sample for dumping PDF information
	
	$Id: dumper.jsp,v 1.3 2010/10/12 13:29:57 rjs Exp $
--%>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>pCOS J2EE Dumper JSP Example</title>
</head>
<body>
<pre>
<%

    final String	docoptlist = "requiredmode=minimum";
    final String	globaloptlist = "";
    final String	filename = "TET-datatsheet.pdf";

    pCOS p = null;

    int	count, pcosmode;
    int	i, doc;
    boolean plainmetadata;
    String	objtype;

    try
    {
	p = new pCOS();

	/* This is where input files live. Adjust as necessary. */
	String optlist;
	ServletContext context = getServletContext();
	String searchpath = context.getRealPath("/WEB-INF/data");
	optlist = "searchpath={{" + searchpath + "}}";
	p.set_option(optlist);

	p.set_option(globaloptlist);

	if ((doc = p.open_document(filename, docoptlist)) == -1)
	{
	    throw new Exception("ERROR " + p.get_errmsg());
	}

	/* --------- general information (always available) */

	pcosmode = (int) p.pcos_get_number(doc, "pcosmode");

	out.println("   File name: " + p.pcos_get_string(doc,"filename"));

	out.println(" PDF version: " +
	    p.pcos_get_string(doc, "pdfversionstring"));

	out.println("  Encryption: " +
	    p.pcos_get_string(doc, "encrypt/description"));

	out.println("   Master pw: " +
	    ((p.pcos_get_number(doc, "encrypt/master") != 0) ? "yes" : "no"));

	out.println("     User pw: " +
	    ((p.pcos_get_number(doc, "encrypt/user") != 0) ? "yes" : "no"));

	out.println("Text copying: " +
	    ((p.pcos_get_number(doc, "encrypt/nocopy") != 0) ? "no" : "yes"));

	out.println("  Linearized: " +
	    ((p.pcos_get_number(doc, "linearized") != 0) ? "yes" : "no"));

	if (pcosmode == 0)
	{
	    out.println(
		"Minimum mode: no more information available\n");
	}
	else {

	    /* --------- more details (requires at least user password) */

	    out.println("PDF/X status: " + p.pcos_get_string(doc, "pdfx"));

	    out.println("PDF/A status: " + p.pcos_get_string(doc, "pdfa"));

	    boolean xfa_present =
		!p.pcos_get_string(doc, "type:/Root/AcroForm/XFA").equals("null");
	    out.println("    XFA data: " + (xfa_present ? "yes" : "no"));
		
	    out.println("  Tagged PDF: " +
		((p.pcos_get_number(doc, "tagged") != 0) ? "yes" : "no") + "\n");

	    out.println("No. of pages: " +
		(int) p.pcos_get_number(doc, "length:pages"));

	    out.println(" Page 1 size: width=" +
		 (int) p.pcos_get_number(doc, "pages[0]/width") + ", height=" +
		 (int) p.pcos_get_number(doc, "pages[0]/height"));

	    count = (int) p.pcos_get_number(doc, "length:fonts");
	    out.println("No. of fonts: " +  count);

	    for (i = 0; i < count; i++)
	    {
		String fonts;

		fonts = "fonts[" + i + "]/embedded";
		if (p.pcos_get_number(doc, fonts) != 0)
		    out.print("embedded ");
		else
		    out.print("unembedded ");

		fonts = "fonts[" + i + "]/type";
		out.print(p.pcos_get_string(doc, fonts) + " font ");
		fonts = "fonts[" + i + "]/name";
		out.println(p.pcos_get_string(doc, fonts));
	    }

	    out.println();

	    plainmetadata = p.pcos_get_number(doc, "encrypt/plainmetadata") != 0;

	    if (pcosmode == 1 && !plainmetadata &&
		   p.pcos_get_number(doc, "encrypt/nocopy") != 0)
	    {
		out.print(
		    "Restricted mode: no more information available");
	    }
	    else {

		/* ----- document info keys and XMP metadata (requires master pw) */

		count = (int) p.pcos_get_number(doc, "length:/Info");

		for (i = 0; i < count; i++)
		{
		    String info;
		    String key;
		    int len;

		    info = "type:/Info[" + i + "]";
		    objtype = p.pcos_get_string(doc, info);

		    info = "/Info[" + i + "].key";
		    key = p.pcos_get_string(doc, info);
		    len = 12 - key.length();
		    while (len-- > 0) out.print(" ");

		    out.print(key + ": ");

		    /* Info entries can be stored as string or name objects */
		    if (objtype.equals("name") || objtype.equals("string"))
		    {
			info = "/Info[" + i + "]";
			out.println("'" + p.pcos_get_string(doc, info) + "'");
		    }
		    else
		    {
			info = "type:/Info[" + i + "]";
			out.println("(" + p.pcos_get_string(doc, info) +
			     " object)");
		    }
		}

		out.print("\n" + "XMP meta data: ");

		objtype = p.pcos_get_string(doc, "type:/Root/Metadata");
		if (objtype.equals("stream"))
		{
		    byte[] contents;
		    int len;

		    contents = p.pcos_get_stream(doc, "", "/Root/Metadata");
		    out.print(contents.length + " bytes ");
		    out.println("");
		}
		else
		{
		    out.println("not present");
		}
	    }
	}
	p.close_document(doc);
    }
    catch (pCOSException e)
    {
	out.print("pCOS exception occurred in dumper:\n");
	out.print("[" + e.get_errnum() + "] " + e.get_apiname() +
			": " + e.get_errmsg() + "\n");
    }
    catch (Exception e)
    {
	out.println(e.getMessage());
    }
    finally
    {
	if (p != null)
	{
	    p.delete();
	}
    }
%>
</pre>
</body>
</html>
