from pcoslib_py import *

class pCOS(object):

    def __init__(self):
        self.__p = pCOS_new()
        pCOS_set_option(self.__p, "binding={python} objorient")

    # it is recommended not to use __del__ as it is not guaranteed
    # when this will be executed (see Python Esential Reference Page 94).
    # so we also implement a delete method and invalidate self.__p
    # whenever this will be called.
    def __del__(self):
        if (self.__p):
            pCOS_delete(self.__p)

    def delete(self):
        if (self.__p):
            pCOS_delete(self.__p)
        self.__p = 0

    def close_document(self, doc):
        pCOS_close_document(self.__p, doc)

    def convert_to_unicode(self, inputformat, inputstring, optlist):
        return pCOS_convert_to_unicode(self.__p, inputformat, inputstring, optlist)

    def create_pvf(self, filename, data, optlist):
        pCOS_create_pvf(self.__p, filename, data, optlist)

    def delete_pvf(self, filename):
        return pCOS_delete_pvf(self.__p, filename)

    def get_apiname(self):
        return pCOS_get_apiname(self.__p)

    def get_errmsg(self):
        return pCOS_get_errmsg(self.__p)

    def get_errnum(self):
        return pCOS_get_errnum(self.__p)

    def info_pvf(self, filename, keyword):
        return pCOS_info_pvf(self.__p, filename, keyword)

    def open_document(self, filename, optlist):
        return pCOS_open_document(self.__p, filename, optlist)

    def open_document_mem(self, data, optlist):
        return pCOS_open_document_mem(self.__p, data, optlist)

    def pcos_get_number(self, doc, path):
        return pCOS_pcos_get_number(self.__p, doc, path)

    def get_number(self, doc, path):
        return pCOS_get_number(self.__p, doc, path)

    def pcos_get_string(self, doc, path):
        return pCOS_pcos_get_string(self.__p, doc, path)

    def get_string(self, doc, path):
        return pCOS_get_string(self.__p, doc, path)

    def pcos_get_stream(self, doc, optlist, path):
        return pCOS_pcos_get_stream(self.__p, doc, optlist, path)

    def get_stream(self, doc, optlist, path):
        return pCOS_get_stream(self.__p, doc, optlist, path)

    def set_option(self, optlist):
        pCOS_set_option(self.__p, optlist)

